=== debian/rules ===
#!/usr/bin/make -f
%:
	dh $@ 

override_dh_auto_configure:
	dh_auto_configure -- \
		-DCMAKE_BUILD_TYPE:STRING=Release
	# RelWithDebInfo is slower

override_dh_auto_test:
	# Don't run CTest. 
	# Ran by developpers and may timeout on slow platforms.
