=== debian/watch ===
version=3
https://mulcyber.toulouse.inra.fr/frs/?group_id=29 /frs/download\.php/\d+/toulbar2_([\d\.]*)\.orig\.tar\.xz
