=== misc/script/Makefile ===
--- 
+++ 
@@ -1,4 +1,4 @@
-SRCSFULL = $(wildcard tb2*.cpp incop/*.cpp)
+SRCSFULL = $(wildcard tb2*.cpp applis/*.cpp core/*.cpp globals/*.cpp incop/*.cpp search/*.cpp utils/*.cpp vns/*.cpp ToulbarVersion.cpp)
 
 # Comment the following line if BOOST Graph library uninstalled
 BOOST = -DBOOST
@@ -11,7 +11,7 @@
 ifeq ($(BOOST),-DBOOST)
 SRCS = $(SRCSFULL)
 else
-SRCS = $(SRCSFULL:tb2boostgraph.cpp=)
+SRCS = $(SRCSFULL:utils/tb2boostgraph.cpp=)
 endif
 
 ifeq ($(XML),XMLFLAG)
@@ -45,18 +45,19 @@
 
 CFLAGS = -g -Wall -I. $(ILOGFLAGS) $(BOOST) $(XMLI) -DLINUX -DLONGLONG_COST -DWIDE_STRING -DLONGDOUBLE_PROB -DNARYCHAR -DWCSPFORMATONLY
 # -DLINUX # compile on linux computers
-# -DLONGLONG_COST # uses type long long for encoding costs
-# -DWIDE_STRING # uses wide strings (2 bytes per char) for encoding value tuples (including separators)
-# -DLONGDOUBLE_PROB # uses type long double for encoding (log) probabilities
+# -DLONGLONG_COST # uses type long long for encoding costs, to be replaced by -DINT_COST if memory is an issue (but costs are limited to 119304647)
+# -DWIDE_STRING # uses wide strings (2 bytes per char instead of one) for encoding value tuples (including separators)
+# -DLONGDOUBLE_PROB # uses type long double for encoding (log) probabilities instead of type double if using -DDOUBLE_PROB
 # -DNARYCHAR # pretty prints of nary constraints (including separators)
 # -DWCSPFORMATONLY # assumes positive domains starting at value 0 (as in the wcsp format file) *** Incompatible with Numberjack ***
 # -DNUMBERJACK # 
+# -DOPENMPI # enables variable neighborhood search
 # -ftrapv -g3 # catches numerical integer overflows
 
 OFLAGS = -O3 -DNDEBUG
 # -O3 -DNDEBUG
 
-PFLAGS = 
+PFLAGS =
 # -pg -g3
 
 BUILD = $(CC) -shared
@@ -84,6 +85,6 @@
 	$(CC) $(OFLAGS) $(CFLAGS) -o $@ $< $(ILOGLIBS) -L. -ltb2 -lgmp
 
 clean:
-	-rm -f *.o incop/*.o toulbar2 libtb2.so iloglue toulbar2test
+	-rm -f *.o applis/*.o core/*.o globals/*.o incop/*.o search/*.o utils/*.o vns/*.o toulbar2 libtb2.so iloglue toulbar2test
 
 all: toulbar2
